## multipath-tools 0.4.9

=== Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#

#
# Try to supply the linux kernel headers.
#
ifeq    ($(KRNLSRC),)
KRNLLIB = /lib/modules/$(shell uname -r)
ifeq    ($(shell test -r $(KRNLLIB)/source && echo 1),1)
KRNLSRC = $(KRNLLIB)/source
KRNLOBJ = $(KRNLLIB)/build
else
KRNLSRC = $(KRNLLIB)/build
KRNLOBJ = $(KRNLLIB)/build
endif
endif
export KRNLSRC
export KRNLOBJ

BUILDDIRS = \
	libmultipath \
	libmultipath/prioritizers \
	libmultipath/checkers \
	multipath \
	multipathd \
	kpartx

ifeq   ($(MULTIPATH_VERSION),)
VERSION = $(shell basename ${PWD} | cut -d'-' -f3)
else
VERSION = $(MULTIPATH_VERSION)
endif

all: recurse

recurse:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir BUILD=$(BUILD) VERSION=$(VERSION) \
		KRNLSRC=$(KRNLSRC) KRNLOBJ=$(KRNLOBJ) || exit $?; \
	done

recurse_clean:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir clean || exit $?; \
	done

recurse_install:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir install || exit $?; \
	done

recurse_uninstall:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir uninstall || exit $?; \
	done

clean:	recurse_clean
	rm -f multipath-tools.spec
	rm -rf rpms

install:	recurse_install

uninstall:	recurse_uninstall

release:
	sed -e "s/__VERSION__/${VERSION}/" \
	multipath-tools.spec.in > multipath-tools.spec

rpm: release
	rpmbuild -bb multipath-tools.spec

=== libmultipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

SONAME=0
DEVLIB = libmultipath.so
LIBS = $(DEVLIB).$(SONAME)
LIBDEPS = -lpthread -ldl -ldevmapper

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
       hwtable.o blacklist.o util.o dmparser.o config.o \
       structs.o discovery.o propsel.o dict.o \
       pgpolicies.o debug.o regex.o defaults.o uevent.o \
       switchgroup.o uxsock.o print.o alias.o log_pthread.o \
       log.o configure.o structs_vec.o sysfs.o prio.o checkers.o \
       lock.o waiter.o

LIBDM_API_FLUSH = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_no_flush' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_FLUSH)),0)
	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
endif

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(SHARED_FLAGS) $(LIBDEPS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS)
	ln -sf $@ $(DEVLIB)

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(libdir)

uninstall:
	rm -f $(DESTDIR)$(syslibdir)/$(LIBS)

clean:
	rm -f core *.a *.o *.gz *.so *.so.*

=== libmultipath/checkers/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

LIBS= \
	libcheckcciss_tur.so \
	libcheckreadsector0.so \
	libchecktur.so \
	libcheckdirectio.so \
	libcheckemc_clariion.so \
	libcheckhp_sw.so \
	libcheckrdac.so

CFLAGS += -I..

all: $(LIBS)

libcheckdirectio.so: libsg.o directio.o
	$(CC) $(SHARED_FLAGS) -o $@ $^ -laio

libcheck%.so: libsg.o %.o
	$(CC) $(SHARED_FLAGS) -o $@ $^

install:
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do rm -f $(DESTDIR)$(libdir)/$$file; done

clean:
	rm -f core *.a *.o *.gz *.so

=== libmultipath/prioritizers/Makefile ===
# Makefile
#
# Copyright (C) 2007 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

LIBS = \
	libpriorandom.so \
	libprioconst.so \
	libpriohp_sw.so \
	libprioemc.so \
	libpriordac.so \
	libprioalua.so \
	libprionetapp.so \
	libpriodatacore.so \
	libpriohds.so

CFLAGS += -I..

all: $(LIBS)

libprioalua.so: alua.o alua_rtpg.o
	$(CC) $(SHARED_FLAGS) -o $@ $^

libprio%.so: %.o
	$(CC) $(SHARED_FLAGS) -o $@ $^

install: $(LIBS)
	$(INSTALL_PROGRAM) -m 755 libprio*.so $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do rm -f $(DESTDIR)$(libdir)/$$file; done

clean:
	rm -f core *.a *.o *.gz *.so

=== debian/changelog ===
multipath-tools (0.4.9-3ubuntu7) raring; urgency=low

  * Add 0010-fix-extended-partitions.patch: Only expose the
    first two sectors of the extended partition (LP: #1093918).

 -- Phillip Susi <psusi@ubuntu.com>  Fri, 04 Jan 2013 16:14:34 -0500

multipath-tools (0.4.9-3ubuntu6) quantal; urgency=low

  * Rebuild for new armel compiler default of ARMv5t.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 05 Oct 2012 14:00:37 +0100

multipath-tools (0.4.9-3ubuntu5) precise; urgency=low

  * Split kpartx initramfs bits into kpartx-boot for dmraid (LP: #941874)

 -- Phillip Susi <psusi@ubuntu.com>  Tue, 20 Mar 2012 15:26:22 -0400

multipath-tools (0.4.9-3ubuntu4) precise; urgency=low

  * Restore multipath-udeb dependency on multipath-modules (LP: #959749).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 21 Mar 2012 14:34:01 +0000

multipath-tools (0.4.9-3ubuntu3) precise; urgency=low

  * Move kpartx from multipath-udeb to a new kpartx-udeb package
    (LP: #922646).

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 27 Jan 2012 23:04:23 +0000

multipath-tools (0.4.9-3ubuntu2) precise; urgency=low

  * Add 0009-fix-delim.patch: The 'p' delimiter was being added
    when it shouldn't.

 -- Phillip Susi <psusi@ubuntu.com>  Sun, 08 Jan 2012 20:57:47 -0500

multipath-tools (0.4.9-3ubuntu1) precise; urgency=low

  * Merge with Debian (for remaining changes, see 0.4.9-2ubuntu1).

 -- Matthias Klose <doko@ubuntu.com>  Sun, 04 Dec 2011 21:32:48 +0100

multipath-tools (0.4.9-3) unstable; urgency=low

  * [dd85b8b] Add example to kpartx manpage. Committed upstream.
    Thanks to Lars Wirzenius (Closes: 637538)
  * [652acf5] Add Brazilian Portuguese debconf templates translation.
    Thanks to Flamarion Jorge (Closes: 640802)
  * [71df377] Add Danish translation of the debconf templates multipath-tools.
    Thanks to Joe Hansen (Closes: #628225)
  * [19ab90f] Avoid unnecessary linkage to ncurses library.
    Thanks to Sven Joachim (Closes: 646148)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 03 Dec 2011 19:34:59 +0530

multipath-tools (0.4.9-2ubuntu1) oneiric; urgency=low

  * Merge from debian unstable, remaining changes:
    - control:
      * Bump debhelper dependency to install udev rules to
       /lib/udev/rules.d, bump udev dependencies as well.
      * multipath-udeb must not depend on multipath-modules, 
        because the Ubuntu kernel already includes the modules and no 
        package provides m-m.
    - initramfs/hooks: use 95 not 60 for multipath rules priority
    - multipath-tools-boot.init: remove in favor of kpartx.udev rules (at top)
    - kpartx.udev:
      * add rule to load dm-multipath
      * use whole path when running /usr/lib/dmsetup_env
      * call kpartx through dmsetup for mpath-* devices
      * switch $name for $kernel for dmraid rule
    - multipath-tools.preinst: modprobe dm-multipath.
      This will make sure that multipathd will be able to start.
    - patches/1000--set-umask-in-multipathd.patch: Set umask in multipathd.
    - rules: Move udev rules to priority 95, because rules that load
      modules should be >90.
    - Have initramfs local-top start with scsi_wait_scan, and make sure all
      devices have been found before bothering to call udevadm settle.
    - debian/initramfs/local-top: wait for scsi_wait_scan
  * *.install: use /lib*/ instead of /lib/ to catch /lib64
  * debian/initramfs/local-top: remove '--timeout 10' which causes my
    test system to not boot roughly 3 out of 4 times.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 06 Jun 2011 12:31:23 -0500

multipath-tools (0.4.9-2) unstable; urgency=low

  * [2544655] wait harder for multipath init. Thanks to Serge Hallyn for
    the patch
  * [eb87e52] switch to 3.0 quilt source format
  * [e55a306] explictly mention license copyright
  * [52db82f] update vcs headers
  * [8313f77] with dpkg > 1.15.7 we now don't need XC
  * [8fdf077] update short description for multipath udeb package
  * [c409ef3] add misc:Depends for multipath-udeb
  * [c890181] take maintenance of package (Closes: #607911)
  * [09bbbc8] add debugging symbols package. Thanks to Craig Magina.
    (Closes: #609068)
  * [2e6f8a7] spelling/hyphen fixes
  * [97e02e7] add manpage for read-only mappings
  * [5419352] add-r-to-make-resulting-device-read-only. Thanks to Wakko Warner
    for the patch (Closes: #504678)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 05 Mar 2011 03:22:32 +0530

multipath-tools (0.4.9-1) unstable; urgency=low

  [ Guido Günther ]
  * New upstream version 0.4.9 (Closes: #587315, #595127)
  * [500e341] Don't fail "mulitipath-tools start" if multipathd is
    already running (Closes: #587678)
  * [f4e697c] Drop upstream patches:
      * 0001-Fix-udev-rules-for-dmraid.patch
      * 0003-fix-URL-to-FAQ.patch
      * 0004-check-header-file-for-defintion-of-dm_task_no_flush.patch
      * 0005-set-a-soname.patch
      * 0006-add-library-dependencies.patch
      * 0007-multipath-tools-rdac-path-checked-leads-to-I-O-hang-.patch
      * 0010-Dots-are-special-in-groff.patch
      * 0011-multipath-fix-offset-for-containted-slices.patch
  * [678dcb6] Bindings file moved to /etc/multipath
  * [ac2f9d5] Bump standards version
  * [baea3a2] Add upstream homepage
  * [9daa1b8] Remove /usr from $PATH so lintian doesn't assume we're
    calling scripts from $remove_fs.
  * [1a3c85e] Update po files

 -- Guido Günther <agx@sigxcpu.org>  Wed, 01 Sep 2010 15:10:26 +0200

multipath-tools (0.4.8-14ubuntu11) oneiric; urgency=low

  * Fixes some return logic issues in the blacklist.c:_filter_path function
    where using blacklist and blacklist_exceptions would cause multipathd to
    improperly filter paths. (LP: #789229)
    - The patch was created by Christophe Varoqui in 2007.
      + http://www.redhat.com/archives/dm-devel/2007-November/msg00054.html
      + 0013-libmultipath-filter_path-fix_blacklist_filter_exit.patch
    - [serge-hallyn] swap in the whole upstream git commit and call it
      0013-blacklist_exception_issues.patch.



=== debian/control ===
Source: multipath-tools
Section: admin
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 7.0.17ubuntu2), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev
Vcs-Git: git://git.debian.org/git/pkg-lvm/multipath-tools.git
Vcs-Browser: http://git.debian.org/?p=pkg-lvm/multipath-tools.git
Standards-Version: 3.9.1
Homepage: http://christophe.varoqui.free.fr/

Package: multipath-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), initscripts (>= 2.85-16),
 kpartx (>= ${binary:Version}), lsb-base (>= 3), libaio1 (>= 0.3.106-8)
Conflicts: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: multipath-tools-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends}, multipath-tools (= ${binary:Version}), kpartx (= ${binary:Version})
Description: maintain multipath block device access - debugging symbols
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.
 .
 This package includes the debugging symbols

Package: kpartx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: kpartx-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools,
 kpartx (>= ${source:Version}), kpartx (<< ${source:Version}.1~)
Description: Provides kpartx during boot
 This package makes kpartx availible during boot to activate partitions

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools, 
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~),
 kpartx-boot (= ${binary:Version})
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1)
Conflicts: multipath-tools-initramfs (<< 1.0.1+nmu1)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

=== debian/rules ===
#!/usr/bin/make -f

INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
        INSTALL_PROGRAM = install -s
else
        INSTALL_PROGRAM = install
endif

# Work around misp(el) linker bug:
# http://sources.redhat.com/bugzilla/show_bug.cgi?id=10144
DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  OPTFLAGS = "OPTFLAGS=-pipe -Wall -Wunused -Wstrict-prototypes"
endif

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir

	$(MAKE) $(OPTFLAGS) LIB=lib

	touch $@

clean-tree:
	$(MAKE) clean

clean: clean-tree
	dh_testdir
	rm -f build-stamp
	dh_clean
	debconf-updatepo

install:
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	mkdir -p $(CURDIR)/debian/tmp/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=lib
	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
	dh_install -X.rules --fail-missing --sourcedir=$(CURDIR)/debian/tmp
	# initramfs stuff:
	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
	install -D -m 755 debian/initramfs/kpartx.hook $(CURDIR)/debian/kpartx-boot/usr/share/initramfs-tools/hooks/kpartx
	install -D -m 755 debian/initramfs/local-top \
		$(INITRAMFS)/scripts/local-top/multipath
	# reportbug:
	for pkg in "multipath-tools" "multipath-tools-boot"; do \
	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
	done

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_installinit -pmultipath-tools
	dh_installinit -pmultipath-tools --name=multipath-tools-boot --no-start -- start 21 S .
	dh_installudev -pkpartx --priority=95
	dh_installudev -pmultipath-tools --name=multipath --priority=95
	dh_installdebconf -pmultipath-tools-boot
	dh_installman
	dh_makeshlibs --add-udeb=multipath-udeb
	dh_link
	dh_strip --dbg-package=multipath-tools-dbg
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary:	binary-indep binary-arch
.PHONY: binary binary-arch binary-indep unpack configure build clean

## multipath-tools 0.4.9%2Bgit0.4dfdaf2b

=== multipathd/Makefile ===
EXEC = multipathd

include ../Makefile.inc

#
# basic flags setting
#
CFLAGS += -I$(multipathdir)
LDFLAGS += -lpthread -ldevmapper -lreadline -lncurses -ldl \
	   -L$(multipathdir) -lmultipath

#
# debuging stuff
#
#CFLAGS += -DLCKDBG
#CFLAGS += -D_DEBUG_
#CFLAGS += -DLOGDBG

#
# object files
#
OBJS = main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o


#
# directives
#
all : $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(rcdir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(rcdir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm -f $(DESTDIR)$(unitdir)/$(EXEC).service

clean:
	rm -f core *.o $(EXEC) *.gz

=== debian/changelog ===
multipath-tools (0.4.9+git0.4dfdaf2b-7~deb7u2) stable-proposed-updates; urgency=low

  * Non-maintainer upload.
  * Restore "dmsetup export" workaround for Debian.
    The hunk using /lib/udev/dmsetup_env to gather device-mapper information
    needed was lost in the -7 Debian revision upload. Restore the udev rule
    based on the upstream one.
    Revert copying of kpartx/kpartx.rules from upstream sources.
    (Closes: #726296, #726311)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 14 Oct 2013 16:06:08 +0200

multipath-tools (0.4.9+git0.4dfdaf2b-7~deb7u1) stable-proposed-updates; urgency=low

  * 0.4.9+git0.4dfdaf2b-7~deb7u1 for Wheezy multipath updates 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 01 Jul 2013 12:07:59 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-7) unstable; urgency=low

  * [8c5d841] Fix upstream copy of kpartx rules (Closes: #618700)
  * [a3a6c10] Call PREREQS before calling scripts/functions.
    Thanks to Guy Rossin, Michael Prokop
  * [7572c53] Don't plain exit if root is on multipath device.
    Thanks to Guy Rossin (Closes: #704073)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 11 Jun 2013 00:14:50 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-6) unstable; urgency=low

  * [821cc20] Don't fail if no dm aware (root) device is reported
    (Closes: #674733)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 28 May 2012 18:19:12 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-5) unstable; urgency=low

  * [08990d2] Fix root device detection syntax.
    Thanks to Bernhard Reutner-Fischer (Closes: #674029)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 27 May 2012 08:36:40 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-4) unstable; urgency=low

  * [8ab1022] Fix path scope in initscript to accomodate awk from /usr
    (Closes: #663662)
  * [aa5ff3f] Use correct po filename for Brazilian translations.
    Thanks to Adriano Rafael Gomes (Closes: #664371)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 28 Apr 2012 20:21:38 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-3) unstable; urgency=low

  * [d46bb8f] Fix hardening build flags (Closes: #657848)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 12 Mar 2012 20:53:46 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-2) unstable; urgency=low

  * Upload to unstable
  * [4e3eedb] Drop syslog loggin in initrd.
    Thanks to Martin Sofaru (Closes: #661597)
  * [787ad2a] Enable hardening build flags.
    Thanks to Moritz Muehlenhoff (Closes: #657848)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 05 Mar 2012 23:30:52 +0530

multipath-tools (0.4.9+git0.4dfdaf2b-1) experimental; urgency=low

  * [6771cd8] Don't stop multipathd if root is on a multipathed device
    (Closes: #632124)
  * [6a08452] Add Dutch Translation.
    Thanks to Jeroen Schot (Closes: #655459)
  * [e7fc772] Imported Upstream version 0.4.9+git0.4dfdaf2b
  * [43d3f10] Fix slow discovery of multipath devices.
    Thanks to Laurent Bigonville, Frido Roose (Closes: 646900)
  * Dropped Patches
    [37827c5] 0002-Make-user_friendly_names-compatible-to-multipath-too.patch
  * Patches merged upstream
    [2ac8eb8] 0004-add-r-to-make-resulting-device-read-only.patch
    [6eee19a] 0008-kpartx-example-manpage.patch
  * [3a81caa] Refresh patch 0007-do-not-link-against-ncurses.patch
  * [e6f9cdc] install systemd example service under docs
  * [0f87973] add build-arch and build-indep targets
  * [9d94c2d] fix license name in copyright
  * [7884ddc] some more spelling and hyphentation fixes

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 10 Feb 2012 18:25:29 +0530

## multipath-tools 0.4.9+git0.4dfdaf2b

=== libmultipath/Makefile ===
--- 
+++ 
@@ -23,10 +23,16 @@
 	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
 endif
 
+LIBDM_API_COOKIE = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_set_cookie' /usr/include/libdevmapper.h)
+
+ifneq ($(strip $(LIBDM_API_COOKIE)),0)
+	CFLAGS += -DLIBDM_API_COOKIE
+endif
+
 all: $(LIBS)
 
 $(LIBS): $(OBJS)
-	$(CC) $(SHARED_FLAGS) $(LIBDEPS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS)
+	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS) $(LIBDEPS)
 	ln -sf $@ $(DEVLIB)
 
 install:

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

OBJS = main.o

CFLAGS += -I$(multipathdir)
LDFLAGS += -lpthread -ldevmapper -ldl -L$(multipathdir) -lmultipath

EXEC = multipath

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)/etc/udev/rules.d
	$(INSTALL_PROGRAM) -m 644 multipath.rules $(DESTDIR)/etc/udev/rules.d/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man5dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)

uninstall:
	rm $(DESTDIR)/etc/udev/rules.d/multipath.rules
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,11 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-build: build-stamp
+build: build-arch build-indep
+
+build-arch: build-stamp
+build-indep: build-stamp
+
 build-stamp:
 	dh_testdir
 
@@ -47,9 +51,10 @@
 	dh_install -X.rules --fail-missing --sourcedir=$(CURDIR)/debian/tmp
 	# initramfs stuff:
 	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
-	install -D -m 755 debian/initramfs/kpartx.hook $(CURDIR)/debian/kpartx-boot/usr/share/initramfs-tools/hooks/kpartx
 	install -D -m 755 debian/initramfs/local-top \
 		$(INITRAMFS)/scripts/local-top/multipath
+	install -D -m 755 debian/initramfs/init-top \
+		$(INITRAMFS)/scripts/init-top/multipath
 	# reportbug:
 	for pkg in "multipath-tools" "multipath-tools-boot"; do \
 	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
@@ -68,8 +73,8 @@
 	dh_installexamples
 	dh_installinit -pmultipath-tools
 	dh_installinit -pmultipath-tools --name=multipath-tools-boot --no-start -- start 21 S .
-	dh_installudev -pkpartx --priority=95
-	dh_installudev -pmultipath-tools --name=multipath --priority=95
+	dh_installudev -pkpartx
+	dh_installudev -pmultipath-tools --name=multipath
 	dh_installdebconf -pmultipath-tools-boot
 	dh_installman
 	dh_makeshlibs --add-udeb=multipath-udeb

## multipath-tools 0.4.9+git0.9c3c5172

=== debian/changelog ===
multipath-tools (0.4.9+git0.9c3c5172-1) unstable; urgency=low

  * [b6f1bce] Emphasize on the alias feature.
    Thanks to Vincent McIntyre (Closes: #716655)
  * [3eab3e3] Restore multipath's dependence on dmsetup_env tool.
    Thanks to Salvatore Bonaccorso, Gordon Grubert (Closes: #726296, #726311)
  * [1bcf079] Imported Upstream version 0.4.9+git0.9c3c5172
  * [62c8f71] Update README.source with updated instructions
  * [3b4c3db] Enable standard hardening knobs
  * [54ea833] Add build dependency on libudev-dev
  * [94c01e4] Ship mpath persist manpages in the multipath-tools package
  * [d09e731] Update multipath-tools.install for mpathpersist
  * [997abf1] Fix Vcs links

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 05 Nov 2013 12:38:57 +0530

=== debian/control ===
Source: multipath-tools
Section: admin
Priority: extra
Maintainer: Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 5.0.45), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev, dpkg-dev (>= 1.16.1~), libudev-dev
Vcs-Git: git://anonscm.debian.org/pkg-lvm/multipath-tools.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-lvm/multipath-tools.git
Standards-Version: 3.9.1
Homepage: http://christophe.varoqui.free.fr/

Package: multipath-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>= 0.124), initscripts (>= 2.85-16),
 kpartx (>= ${binary:Version}), lsb-base (>= 3), libaio1 (>= 0.3.106-8)
Conflicts: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: multipath-tools-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends}, multipath-tools (= ${binary:Version}), kpartx (= ${binary:Version})
Description: maintain multipath block device access - debugging symbols
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.
 .
 This package includes the debugging symbols

Package: kpartx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 0.086), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools, 
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~)
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1)
Conflicts: multipath-tools-initramfs (<< 1.0.1+nmu1)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,12 @@
   OPTFLAGS = "OPTFLAGS=-pipe -Wall -Wunused -Wstrict-prototypes"
 endif
 
+# For Hardening
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+#
+
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
@@ -25,6 +31,8 @@
 
 build-stamp:
 	dh_testdir
+	
+	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
 
 	$(MAKE) $(OPTFLAGS) LIB=lib
 
@@ -36,13 +44,14 @@
 clean: clean-tree
 	dh_testdir
 	rm -f build-stamp
-	dh_clean
+	dh_prep
 	debconf-updatepo
+	rm -rf debian/*.debhelper.log
 
 install:
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
 
 	mkdir -p $(CURDIR)/debian/tmp/sbin

## multipath-tools 0.5.0

=== multipathd/Makefile ===
--- 
+++ 
@@ -5,9 +5,16 @@
 #
 # basic flags setting
 #
-CFLAGS += -I$(multipathdir)
-LDFLAGS += -lpthread -ldevmapper -lreadline -lncurses -ldl \
-	   -L$(multipathdir) -lmultipath
+CFLAGS += -I$(multipathdir) -I$(mpathpersistdir)
+ifdef SYSTEMD
+	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
+endif
+LDFLAGS += -lpthread -ldevmapper -lreadline
+ifdef SYSTEMD
+	LDFLAGS += -lsystemd-daemon
+endif
+LDFLAGS += -ludev -ldl \
+	-L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist
 
 #
 # debuging stuff
@@ -35,8 +42,11 @@
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
 	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(rcdir)
+ifdef SYSTEMD
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
 	$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
+	$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
+endif
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
 	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
 
@@ -45,6 +55,7 @@
 	rm -f $(DESTDIR)$(rcdir)/$(EXEC)
 	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz
 	rm -f $(DESTDIR)$(unitdir)/$(EXEC).service
+	rm -f $(DESTDIR)$(unitdir)/$(EXEC).socket
 
 clean:
 	rm -f core *.o $(EXEC) *.gz

=== debian/changelog ===
multipath-tools (0.5.0-6) unstable; urgency=medium

  [ Mauricio Faria de Oliveira ]
  * Build multipath-udeb with static libgcc (Closes: #779579)

 -- Mauricio Faria de Oliveira <mauricfo@linux.vnet.ibm.com>  Tue, 03 Mar 2015 15:52:58 -0300

multipath-tools (0.5.0-5) unstable; urgency=medium

  * [5f967eb] Better daemon status in init's status action.
    Thanks to Joerg Jaspert (Closes: #755483)
  * [8455ce6] Introduce kpartx-udeb.
    Thanks to Philip Susi (Closes: #751029)
  * [72419cd] Fix syntax error in debian/control file

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 16 Sep 2014 14:59:11 +0530

multipath-tools (0.5.0-4) unstable; urgency=medium

  * [55c2ef2] Drop systemd support in multipath-tools
    (Closes: #759849, #760182, #760189)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 05 Sep 2014 17:50:03 +0530

multipath-tools (0.5.0-3) unstable; urgency=medium

  * [6c453f2] Install sytemd files into /lib/systemd/system/

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 01 Sep 2014 15:49:28 +0530

multipath-tools (0.5.0-2) unstable; urgency=medium

  * [631296d] Add libsystemd-daemon-dev to Build-Dep (Closes: #759849)
  * [742c706] Add systemd files
  * [0783f2e] Add lintian override because, for systemd, we are
    shipping upstream's service file. There is no point in redoing
    the whole stuff of renaming the systemd service file.
    Also, it is yet to see how systemd will handle many of the pre/post
    checks that we had the flexibility to do in the shell init scirpt

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 01 Sep 2014 14:10:40 +0530

multipath-tools (0.5.0-1) unstable; urgency=low

  * [955018b] Imported Upstream version 0.5.0
  * [10f0910] We now ship the systemd service file
  * [9606cde] Drop socket activation through udev rules
  * [1fe46fb] Add patch 0012-format-security-build-fixes.patch 
  * [2678d22] Drop patch 0006-read-only-partition-mappings-manpage.patch
    Applied upstream
  * [e191244] Drop Conflicts with Breaks
  * [0e87578] Add status to init scripts
  * [1d3aa3d] Add Italian translation for debconf.
    Thanks to Beatrice Torraca (Closes: #729797)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 09 Mar 2014 16:52:09 +0530

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>= 0.124), initscripts (>= 2.85-16),
  kpartx (>= ${binary:Version}), lsb-base (>= 3), libaio1 (>= 0.3.106-8)
-Conflicts: multipath-tools-initramfs (<= 1.0.1),
+Breaks: multipath-tools-initramfs (<= 1.0.1),
  multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
 Suggests: multipath-tools-boot
 Description: maintain multipath block device access
@@ -49,7 +49,7 @@
 Depends: ${misc:Depends}, initramfs-tools, 
  multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~)
 Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1)
-Conflicts: multipath-tools-initramfs (<< 1.0.1+nmu1)
+Breaks: multipath-tools-initramfs (<< 1.0.1+nmu1)
 Description: Support booting from multipath devices
  This package contains the necessary support for booting from a multipath
  device:
@@ -63,7 +63,7 @@
 Package: multipath-udeb
 Package-Type: udeb
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules
+Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb
 Section: debian-installer
 Description: maintain multipath block device access - udeb package
  This is a udeb, or a microdeb, for the debian-installer.
@@ -71,3 +71,14 @@
  These tools are in charge of maintaining the disk multipath device maps and
  react to path and map events.
 
+Package: kpartx-udeb
+Package-Type: udeb
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Section: debian-installer
+Description: create device mappings for partitions - udeb package
+ This is a udeb, or a microdeb, for the debian-installer.
+ .
+ Kpartx can be used to set up device mappings for the partitions of any
+ partitioned block device. It is part of the Linux multipath-tools.
+

=== debian/rules ===
--- 
+++ 
@@ -23,10 +23,11 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+export DISABLE_SYSTEMD = 1
 
 build: build-arch build-indep
 
-build-arch: build-stamp
+build-arch: build-multipath-udeb-stamp build-stamp
 build-indep: build-stamp
 
 build-stamp:
@@ -38,15 +39,30 @@
 
 	touch $@
 
+# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579)
+build-multipath-udeb-stamp:
+	dh_testdir
+
+	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" $(MAKE) $(OPTFLAGS) LIB=lib
+	
+	# store files for install target
+	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
+	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=lib
+
+	$(MAKE) clean
+
+	touch $@
+
 clean-tree:
 	$(MAKE) clean
 
 clean: clean-tree
 	dh_testdir
-	rm -f build-stamp
+	rm -f build-stamp build-multipath-udeb-stamp
 	dh_prep
 	debconf-updatepo
 	rm -rf debian/*.debhelper.log
+	rm -rf debian/tmp-multipath-udeb
 
 install:
 	dh_testdir
@@ -57,7 +73,8 @@
 	mkdir -p $(CURDIR)/debian/tmp/sbin
 	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=lib
 	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
-	dh_install -X.rules --fail-missing --sourcedir=$(CURDIR)/debian/tmp
+	dh_install -X.rules --fail-missing -Nmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp
+	dh_install -X.rules --fail-missing -pmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp-multipath-udeb
 	# initramfs stuff:
 	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
 	install -D -m 755 debian/initramfs/local-top \
@@ -80,6 +97,7 @@
 	dh_installchangelogs ChangeLog
 	dh_installdocs
 	dh_installexamples
+	dh_lintian
 	dh_installinit -pmultipath-tools
 	dh_installinit -pmultipath-tools --name=multipath-tools-boot --no-start -- start 21 S .
 	dh_installudev -pkpartx
